(*
    ||M||  This file is part of HELM, an Hypertextual, Electronic        
    ||A||  Library of Mathematics, developed at the Computer Science     
    ||T||  Department, University of Bologna, Italy.                     
    ||I||                                                                
    ||T||  HELM is free software; you can redistribute it and/or         
    ||A||  modify it under the terms of the GNU General Public License   
    \   /  version 2 or (at your option) any later version.              
     \ /   This software is distributed as is, NO WARRANTY.              
      V_______________________________________________________________ *)

module E = Entity

type id = E.id

type qid = id * bool * id list (* qualified identifier: name, local?, path *)

type term = Sort of bool              (* sorts: true = TYPE, false = PROP *)
	  | GRef of qid * term list   (* reference: name, arguments *)
	  | Appl of term * term       (* application: argument, function *)
	  | Abst of id * term * term  (* abstraction: name, domain, scope *)
	  
type command = Section of (bool * id) option  (* section: Some true = open, Some false = reopen, None = close last *)
	     | Context of qid option          (* context: Some = last node, None = root *)
	     | Block of id * term             (* block opener: name, domain *)
	     | Decl of id * term              (* declaration: name, domain *)
	     | Def of id * term * bool * term (* definition: name, domain, transparent?, body *)
