(*
    ||M||  This file is part of HELM, an Hypertextual, Electronic        
    ||A||  Library of Mathematics, developed at the Computer Science     
    ||T||  Department, University of Bologna, Italy.                     
    ||I||                                                                
    ||T||  HELM is free software; you can redistribute it and/or         
    ||A||  modify it under the terms of the GNU General Public License   
    \   /  version 2 or (at your option) any later version.              
     \ /   This software is distributed as is, NO WARRANTY.              
      V_______________________________________________________________ *)

module U  = NUri
module L  = Log
module E  = Entity
module Z  = Bag
module ZE = BagEnvironment
module ZT = BagType

(* Interface functions ******************************************************)

(* to share *)
let type_check err f st = function
   | ra, na, uri, E.Abst t ->
      let err msg = err (L.Uri uri :: msg) in      
      let f xt tt = ZE.set_entity (f tt) (ra, na, uri, E.Abst xt) in
      ZT.type_of err f st Z.empty_lenv t
   | ra, na, uri, E.Abbr t ->
      let err msg = err (L.Uri uri :: msg) in
      let f xt tt = ZE.set_entity (f tt) (ra, na, uri, E.Abbr xt) in
      ZT.type_of err f st Z.empty_lenv t
   | _, _, _, E.Void       -> assert false
