(*
    ||M||  This file is part of HELM, an Hypertextual, Electronic        
    ||A||  Library of Mathematics, developed at the Computer Science     
    ||T||  Department, University of Bologna, Italy.                     
    ||I||                                                                
    ||T||  HELM is free software; you can redistribute it and/or         
    ||A||  modify it under the terms of the GNU General Public License   
    \   /  version 2 or (at your option) any later version.              
     \ /   This software is distributed as is, NO WARRANTY.              
      V_______________________________________________________________ *)

type rtm

type message = (rtm, Brg.term) Log.message

val empty_rtm: rtm

val get: rtm -> int -> Brg.bind

val push: rtm -> Entity.node_attrs -> Brg.bind -> rtm

val xwhd: Layer.status -> rtm -> int option -> Brg.term -> rtm * Brg.term 

(* arguments: expected type, inferred type *) 
val are_convertible: 
   Layer.status -> rtm -> int option -> Brg.term -> rtm -> int option -> Brg.term -> bool

val specs: (Layer.status, rtm, Brg.term) Log.specs
