(*
    ||M||  This file is part of HELM, an Hypertextual, Electronic        
    ||A||  Library of Mathematics, developed at the Computer Science     
    ||T||  Department, University of Bologna, Italy.                     
    ||I||                                                                
    ||T||  HELM is free software; you can redistribute it and/or         
    ||A||  modify it under the terms of the GNU General Public License   
    \   /  version 2 or (at your option) any later version.              
     \ /   This software is distributed as is, NO WARRANTY.              
      V_______________________________________________________________ *)

type status

type layer

val initial_status: unit -> status

val refresh_status: status -> status

val infinite: layer

val finite: int -> layer

val one: layer

val two: layer

val unknown: status -> layer

val minus: status -> layer -> int -> layer

val to_string: status -> layer -> string

val assert_not_zero: status -> layer -> bool

val assert_zero: status -> layer -> bool

val assert_equal: status -> layer -> layer -> bool

val is_not_zero: status -> layer -> bool

val are_equal: status -> layer -> layer -> bool
