(*
    ||M||  This file is part of HELM, an Hypertextual, Electronic        
    ||A||  Library of Mathematics, developed at the Computer Science     
    ||T||  Department, University of Bologna, Italy.                     
    ||I||                                                                
    ||T||  HELM is free software; you can redistribute it and/or         
    ||A||  modify it under the terms of the GNU General Public License   
    \   /  version 2 or (at your option) any later version.              
     \ /   This software is distributed as is, NO WARRANTY.              
      V_______________________________________________________________ *)

type ('b, 'c) item = Term of 'b * 'c
                   | LEnv of 'b
                   | Warn of string
                   | Uri  of NUri.uri

type ('b, 'c) message = ('b, 'c) item list

type ('a, 'b, 'c) specs = {
   pp_term: 'a -> 'b -> out_channel -> 'c -> unit;
   pp_lenv: 'a -> out_channel -> 'b -> unit
}

val specs: (unit, unit, unit) specs

val log: 'a -> ('a, 'b, 'c) specs -> int -> ('b, 'c) message -> unit

val error: 'a -> ('a, 'b, 'c) specs -> ('b, 'c) message -> unit

val items1: string -> ('b, 'c) message

val t_items1: string -> 'b -> 'c -> ('b, 'c) message

val et_items1:
   string -> 'b -> string -> 'c -> ('b, 'c) message

val et_items2:
   string -> 'b -> string -> 'c -> 
   ?sc2:string -> ?c2:'b -> string -> 'c -> 
   ('b, 'c) message

val et_items3:
   string -> 'b -> string -> 'c -> 
   ?sc2:string -> ?c2:'b -> string -> 'c -> 
   ?sc3:string -> ?c3:'b -> string -> 'c ->
   ('b, 'c) message

val warn: int -> string -> unit
