(*
    ||M||  This file is part of HELM, an Hypertextual, Electronic        
    ||A||  Library of Mathematics, developed at the Computer Science     
    ||T||  Department, University of Bologna, Italy.                     
    ||I||                                                                
    ||T||  HELM is free software; you can redistribute it and/or         
    ||A||  modify it under the terms of the GNU General Public License   
    \   /  version 2 or (at your option) any later version.              
     \ /   This software is distributed as is, NO WARRANTY.              
      V_______________________________________________________________ *)

type och = string -> unit

type attr = string * string

type pp = och -> int -> unit

val export_entity: ('term -> pp) -> 'term Entity.entity -> unit

val tag: string -> attr list -> ?contents:pp -> pp 

val sort: string

val lref: string

val gref: string

val cast: string

val appl: string

val proj: string

val abst: string

val abbr: string

val void: string

val position: int -> attr

val uri: Entity.uri -> attr

val layer: Layer.status -> Layer.layer -> attr

val name: Entity.node_attrs -> attr

val apix: Entity.node_attrs -> attr

val kind: Entity.node_attrs -> attr

val meta: Entity.root_attrs -> attr

val info: Entity.root_attrs -> attr list
